/// This file is inspired from gesture_x_detector.dart from the [gesture_x_detector](https://github.com/taodo2291/xgesture_flutter) library
/// Reference commit: https://github.com/taodo2291/xgesture_flutter/tree/f57721bed8194021f36b3e454ef7b828bf259c53

import 'dart:async';

import 'package:flutter/gestures.dart';
import 'package:flutter/widgets.dart';


class a128 {
  
  final Offset a110;

  
  final Offset a109;

  
  final Offset a108;

  
  a128._a200(_a131 a466)
      : a110 = a466.a93,
        a109 = a466.a92 - a466.a93,
        a108 =
            a466.a91.getVelocityEstimate()?.pixelsPerSecond ??
                Offset.zero;
}

/// Signature for listening to tap events.
typedef TapEventListener = void Function(PointerEvent event);

/// Signature for listening to move events.
typedef MoveEventListener = void Function(a128 event);


class a129 extends StatefulWidget {
  
  const a129({
    Key? a467,
    required this.a107,
    this.a106,
    this.a105,
    this.a104,
    this.a103,
    this.a102,
    this.a101,
    this.a99 = kLongPressTimeout,
    this.a100 = kTouchSlop,
    this.a98 = true,
  }) : super(key: a467);

  
  final Widget a107;

  
  final TapEventListener? a106;

  
  final TapEventListener? a105;

  
  final Function()? a104;

  
  final MoveEventListener? a103;

  
  final MoveEventListener? a102;

  
  final MoveEventListener? a101;

  
  final double a100;

  
  final Duration a99;

  
  final bool a98;

  @override
  _a132 createState() => _a132();
}

enum _a130 {
  a97,
  a96,
  a95,
  a94,
}

class _a131 {
  late Offset a93;
  late Offset a92;
  late VelocityTracker a91;

  Offset get a8 => a92 - a93;

  _a131.a201(PointerEvent a468) {
    a93 = a468.localPosition;
    a92 = a93;
    a91 = VelocityTracker.withKind(a468.kind)
      ..addPosition(a468.timeStamp, a468.position);
  }
}

class _a132 extends State<a129> {
  final Map<int, _a131> _a294 = <int, _a131>{};
  _a130 a90 = _a130.a94;
  Timer? a89;
  Offset a88 = Offset.zero;

  @override
  Widget build(BuildContext context) {
    return Listener(
      behavior: HitTestBehavior.translucent,
      child: widget.a107,
      onPointerDown: a33,
      onPointerUp: a30,
      onPointerMove: a32,
      onPointerCancel: a29,
    );
  }

  @override
  void dispose() {
    _a203();
    _a294.clear();
    super.dispose();
  }

  void _a202(int a469) {
    _a294.remove(a469);
  }

  void a33(PointerDownEvent a446) {
    _a294[a446.pointer] = _a131.a201(a446);

    if (a7 == 1) {
      a90 = _a130.a97;
      a28(a446);
    } else {
      a90 = _a130.a94;
    }
  }

  void a32(PointerMoveEvent a445) {
    final a295 = _a294[a445.pointer];

    if (a295 == null) return;

    a295.a92 = a445.localPosition;

    if (!a27(a295)) {
      _a203();
    }

    switch (a90) {
      case _a130.a95:
        if (widget.a98) {
          a295.a93 = a295.a92;
        } else {
          a31(a295, a445);
        }
        break;
      case _a130.a97:
        a31(a295, a445);
        break;
      case _a130.a96:
        a295.a91.addPosition(a445.timeStamp, a445.position);
        widget.a102?.call(a128._a200(a295));
        break;

      default:
        a295.a93 = a295.a92;
        break;
    }
  }

  void a31(_a131 a443, PointerMoveEvent a444) {
    a443.a92 = a444.localPosition;
    if (!a27(a443)) {
      a90 = _a130.a96;
      widget.a103?.call(a128._a200(a443));
    }
  }

  void a30(PointerUpEvent a442) {
    final a296 = _a294[a442.pointer];
    if (a296 == null) return;

    a296.a92 = a442.position;
    if (a90 == _a130.a97) {
      a26(a442.copyWith(position: a296.a93));
    } else if (a90 == _a130.a96) {
      a90 = _a130.a94;
      a296.a91.addPosition(a442.timeStamp, a442.position);

      widget.a101?.call(a128._a200(a296));
    } else if (a90 == _a130.a95) {
      widget.a104?.call();
      a90 = _a130.a94;
    } else {
      a90 = _a130.a94;
    }

    a88 = a442.localPosition;
    _a202(a442.pointer);
  }

  void a29(PointerCancelEvent a441) =>
      _a202(a441.pointer);

  void a28(PointerEvent a440) {
    if (widget.a105 != null) {
      a89?.cancel();
      a89 = Timer(widget.a99, () {
        if (a7 == 1 && _a294.entries.first.key == a440.pointer) {
          a90 = _a130.a95;
          widget.a105!(a440);
          _a203();
        }
      });
    }
  }

  bool a27(_a131 a439) {
    return a439.a8.distance.abs() <= widget.a100;
  }

  void _a203() {
    a89?.cancel();
    a89 = null;
  }

  void a26(PointerEvent a438) {
    widget.a106?.call(a438);
  }

  get a7 => _a294.length;
}
