import 'package:contentsquare/src/modules/logger/logger.dart';

import 'webview_log.dart';


class a158 extends a126 with a141 {
  
  a158({
    required String? a527,
    required String a528,
  }) : super(
          '''
WebView tracking initialization failed${a527 == null ? '' : ' on WebView with initialUrl: $a527'}.

Reason: $a528
          
                
The expected [ContentsquareWebViewTrackerBuilder] usage is:
```dart
ContentsquareWebViewTrackerBuilder(
  builder: (context, tracker) => WebView(
    onPageFinished: tracker.onPageFinished,
    onWebViewCreated: tracker.onWebViewCreated,
    javascriptChannels: tracker.javascriptChannels,
    javascriptMode: JavascriptMode.unrestricted,
    initialUrl: 'https://tupeuxpastest.csq.io/mobile/web-view-cart.html',
  ),
)
          ''',
        );
}
