library contentsquare;

import 'package:contentsquare/src/modules/gestures/cs_gesture_detector.dart';
import 'package:contentsquare/src/modules/screengraph/hit_test/get_tvp_at_hit_position.dart';
import 'package:contentsquare_platform_interface/contentsquare_platform_interface.dart';
import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';

import '../contentsquare.dart';

/// ContentsquareRoot widget
///
/// Place it at the root of your app to provide your app with zoning features
class ContentsquareRoot extends StatelessWidget {
  /// ContensquareRoot widget constructor
  const ContentsquareRoot({Key? key, required this.child}) : super(key: key);

  /// Child widget
  final Widget child;

  void _a188({
    required ContentsquareGesture a456,
    required Offset a457,
    ContentsquareGestureData? a458,
  }) {
    final a274 = a251(a457);

    
    
    for (var a275 in a274) {
      Contentsquare().sendTouchEvent(
        type: a456,
        version: version,
        data: TouchEventData(path: a275, gestureData: a458),
      );
    }
  }

  @override
  Widget build(BuildContext context) {
    return a134(
      a84: (position) => _a188(
        a457: position,
        a456: ContentsquareGesture.tap,
      ),
      a83: (position) => _a188(
        a457: position,
        a456: ContentsquareGesture.longPress,
      ),
      a82: (position, data) => _a188(
        a457: position,
        a456: ContentsquareGesture.drag,
        a458: data,
      ),
      a81: (position, data) => _a188(
        a457: position,
        a456: ContentsquareGesture.flick,
        a458: data,
      ),
      a85: child,
    );
  }
}
