import 'dart:math';

import 'package:contentsquare_platform_interface/contentsquare_platform_interface.dart';
import 'package:flutter/gestures.dart';
import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';

import 'gesture_listener.dart';


class a134 extends StatelessWidget {
  
  final Widget a85;

  
  final Function(Offset position)? a84;

  
  final Function(Offset position)? a83;

  
  final Function(Offset position, ContentsquareGestureData data)? a82;

  
  final Function(Offset position, ContentsquareGestureData data)? a81;

  
  const a134({
    Key? a477,
    required this.a85,
    this.a84,
    this.a83,
    this.a82,
    this.a81,
  }) : super(key: a477);

  bool _a210(a128 a478) {
    return a478.a109.distance.isFinite && a478.a108.isFinite;
  }

  void _a211(PointerEvent a479) {
    a84?.call(a479.position);
  }

  void _a212(PointerEvent a480) {
    a83?.call(a480.position);
  }

  void _a213(a128 a481) {
    final a309 = _a214(a481.a109);
    if (a309 == null) return;

    if (!_a210(a481)) return;

    final ContentsquareGestureData a310 = ContentsquareGestureData(
        distance: a481.a109.distance.toInt(),
        direction: a309,
        velocity:
            max(a481.a108.dx.abs(), a481.a108.dy.abs()).toInt());

    if (a310.velocity >= kMinFlingVelocity) {
      a81?.call(a481.a110, a310);
    } else {
      a82?.call(a481.a110, a310);
    }
  }

  static ContentsquareGestureDirection? _a214(Offset a482) {
    if (a482.dx == 0 && a482.dy == 0) return null;

    if (a482.dx.abs() <= a482.dy.abs()) {
      /// Vertical Gesture
      /// gestureDirection = CSGestureDirection.down OR CSGestureDirection.up
      return a482.dy > 0
          ? ContentsquareGestureDirection.down
          : ContentsquareGestureDirection.up;
    }

    /// Horizontal Gesture
    /// gestureDirection = CSGestureDirection.right OR CSGestureDirection.left
    return a482.dx > 0
        ? ContentsquareGestureDirection.right
        : ContentsquareGestureDirection.left;
  }

  @override
  Widget build(BuildContext context) {
    return a129(
      a106: _a211,
      a105: _a212,
      a101: _a213,
      a107: a85,
    );
  }
}
