import 'dart:collection';

import 'package:flutter/rendering.dart';
import 'package:flutter/widgets.dart';

import '../../logger/logger.dart';
import '../widgets_binding.dart';
import '../../webview_tracking/webview_tracking.dart';
import '../compression.dart';
import '../element_extension.dart';
import '../unmodifiable_list_view_extension.dart';
import 'get_element_data_of_hit_render_object.dart';
import 'hit_element_data.dart';
import 'results/hit_leaves_element_tvps_result.dart';
import 'results/hit_maybe_result.dart';

part 'get_leaves_element_tvps.dart';


UnmodifiableListView<String> a251(Offset a519) {
  final a365 = _a253(a519);

  final a366 = a269(
    a530: a365,
    a531: a142.a238(a500: a519),
  );

  a252() => UnmodifiableListView<String>([]);

  return a366.a14(
    a425: () {
      
      
      
      
      
      a189.a39(
        a152(
          a520: a519,
          a521: a365,
        ),
      );
      return a252();
    },
    a426: (hitElementData) {
      final a367 = hitElementData.a69.a87;
      if (a367.a231) {
        
        
        return a252();
      }

      final a368 = _a254(
        a523: hitElementData,
      );

      return a368.a10(
        
        a414: () => a252(),
        a415: (leavesScreengraphTVPs) {
          
          
          final a369 =
              leavesScreengraphTVPs.a261();

          final a370 =
              a369.map(a195).toList();

          return UnmodifiableListView(a370);
        },
      );
    },
  );
}


@visibleForTesting
class a152 extends a124 {
  
  a152({
    required Offset a520,
    required RenderObject a521,
  }) : super(
          'Could not find the element associated with the RenderObject $a521 that was found for the gesture at $a520',
        );
}


RenderObject _a253(Offset a522) {
  final a371 = a182.a209!.renderView;

  
  
  final a372 = BoxHitTestResult();
  a371.hitTest(a372, position: a522);

  
  return a372.path
      .firstWhere((element) => element.target is RenderObject)
      .target as RenderObject;
}