import 'dart:developer';

import 'package:flutter/rendering.dart';


extension a185 on RenderObject {
  
  Rect? get a232 => _a234(a494: true);

  
  Rect? get a233 => _a234(a494: false);

  
  Rect? _a234({required bool a494}) {
    final a332 = this;

    
    
    
    
    
    if (a332 is RenderView) {
      
      
      
      
      return a332.child?._a234(
        a494: a494,
      );
    } else if (a332 is RenderBox) {
      return _a236(
        a332,
        a497: a494,
      );
    } else if (a332 is RenderSliver) {
      return _a237(
        a332,
        a499: a494,
      );
    } else {
      log(
        'The RenderObject of type ${a332.runtimeType} is not supported. Therefore its size cannot be determined.',
      );
      return null;
    }
  }

  
  Rect _a235({
    required bool a495,
  }) {
    if (!a495) {
      return paintBounds;
    }

    
    
    
    final a333 = getTransformTo(null).getTranslation();
    return paintBounds.shift(Offset(a333.x, a333.y));
  }
}


Rect? _a236(
  RenderBox a496, {
  required bool a497,
}) {
  if (!a496.hasSize) {
    return null;
  }

  return a496._a235(
    a495: a497,
  );
}


Rect? _a237(
  RenderSliver a498, {
  required bool a499,
}) {
  if (a498.geometry == null) {
    return null;
  }

  return a498._a235(
    a495: a499,
  );
}
