import 'dart:convert';

import 'package:contentsquare/contentsquare.dart';
import 'package:contentsquare/src/modules/logger/logger.dart';
import 'package:contentsquare/src/modules/webview_tracking/adapters/js_event_to_dart_sdk_adapter.dart';
import 'package:contentsquare/src/modules/webview_tracking/javascript_event_handler.dart';
import 'package:contentsquare/src/modules/webview_tracking/logs/invalid_json_log.dart';
import 'package:contentsquare/src/modules/webview_tracking/logs/screengraph_retrieval_error_logs/tvp_not_found_log.dart';
import 'package:contentsquare_platform_interface/contentsquare_platform_interface.dart';


class a159 extends a168 {
  
  a159({
    required this.a51,
    required this.a50,
  });

  
  final Contentsquare a51;

  
  final String? Function() a50;

  
  static const _a385 = 'eventJson';

  
  @override
  final List<String> a0 = [_a385];

  @override
  Future<void> a13(Map<String, dynamic> a421) async {
    try {
      final a386 = a50();

      if (a386 == null) {
        a189.a39(a176());
        return;
      }

      final a387 = jsonDecode(a421[_a385]);

      final a388 = a387['type'];
      final a389 = ContentsquareGestureInt.fromInt(a388);

      final a390 = a387['data'];

      if (a389 == ContentsquareGesture.pageView) {
        final a391 = a390['url'];
        return a51.send(a391);
      }

      return a51.sendTouchEvent(
        type: a389,
        version: a387['version'],
        data: TouchEventData.fromJson(a390)
            .copyWithPrefixedPath('$a386|webview|'),
      );
    } catch (error) {
      a189.a39(
        a143(
          a501: ContentsquareJavascriptEventEnum.sendMessage,
          a502: '$error',
        ),
      );
    }
  }
}
